//
// input.c
//

#include "core.h"
#include "input.h"


/**
 * Push 3.141592654 (@f$ \approx \pi @f$) on stack.
 */
void key_pi() {
  reg[A][SIGNS]  = 0x00;
  reg[A][M_HIGH] = 3;
  reg[A][M+1]    = 1;
  reg[A][M+2]    = 4;
  reg[A][M+3]    = 1;
  reg[A][M+4]    = 5;
  reg[A][M+5]    = 9;
  reg[A][M+6]    = 2;
  reg[A][M+7]    = 6;
  reg[A][M+8]    = 5;
  reg[A][M_ONES] = 4;
  reg[A][E_TENS] = 0;
  reg[A][E_ONES] = 0;

  push(reg[A]);
}



/**
 * Called when "+" is pressed.
 */
void key_plus() {
  copy_reg(reg[A], reg[X]);
  copy_reg(reg[B], reg[Y]);
  plus(reg[R], reg[A], reg[B]);
  if (flags & INFTY) {
    overflow(reg[R]);
    flags = 0x00;
  } else {
    pop();
    pop();
    push(reg[R]);
  }
}


/**
 * Called when "enter" is pressed.
 */
void key_enter() {
  enter();
}

void key_c() {
  pop();
}


/**
 * Call subroutine assigned to pressed key.
 */
void call(int key) {
  switch(key) {
//    case 's': { key_sin(); break; }
//    case 'a': { key_asin(); break; }
    case 'p': { key_pi(); break; }
    case 'c': { key_c();  break; }
//    case '0': { key_digit(0); break; }
//    case '1': { key_digit(1); break; }
//    case '2': { key_digit(2); break; }
//    case '3': { key_digit(3); break; }
//    case '4': { key_digit(4); break; }
//    case '5': { key_digit(5); break; }
//    case '6': { key_digit(6); break; }
//    case '7': { key_digit(7); break; }
//    case '8': { key_digit(8); break; }
//    case '9': { key_digit(9); break; }
    case 10: { key_enter(); break; }
    case '+': { key_plus(); break; }
  }
}
